#include <stdio.h>


typedef struct FichaAlumno {
	char apellidos[30];
	char nombre[15];
	unsigned char edad;
	float talla;
} Ficha;

typedef void (*PunteroDeFuncion)(Ficha *);

int iterador(Ficha * p, int numElementos, PunteroDeFuncion procesar);

void imprimir(Ficha * p);
void imprimir2(Ficha * p);

int main(int argc, char *argv[])
{
	Ficha lista[] = {
			{"Garca Prez", "Primero", 19, 1.80},
			{"Rodrguez Rodrguez", "Segundo", 17, 1.62},
			{"Garca Prez", "Tercero", 19, 1.80},
			{"","",0,0}
	};
	iterador(lista,3,&imprimir);
	return 0;
}

int iterador(Ficha * p, int numElementos, PunteroDeFuncion procesar)
{
	int i;
	for(i=0; i<numElementos;i++)
		procesar(p+i);
	return 0;
}

void imprimir(Ficha * p)
{
	printf("%30s%16s%4d%6.2f\n", p->apellidos,
			p->nombre,
			p->edad,
			p->talla);
}

void imprimir2(Ficha * p)
{
	printf("D. %s %s, de %d aos de edad y %.2f metros de talla.\n",
			p->nombre,
			p->apellidos,
			p->edad,
			p->talla);
}
