#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "aplicacion.h"

/*
	Esta parte del programa es fija,
	no requiere modificaciones.
 */

void ssalir(GlobRef g)
{
	charRef nosVamos = pedir("\n\nDesea salir del programa (S/N)?... ");
	if ('S' == toupper((int)nosVamos[0]))
		g->salirDePrograma = 1;
}

void volver(GlobRef g)
{
	printf("\n\n***\7Opcin incorrecta***\n\n");
	return;
}

void distribuidor(	GlobRef  g,
		charRef  men,
		charRef  opc,
		funRef * fun)
{
	char buf[16];
	char orden;
	int numOpciones = 0;
	int numFunciones = 0;
	int i;
	/*
		Nueva estructura de datos
	 */
	funRef * f;
	/*
		Se determina el nmero de opciones
	 */
	numOpciones = strlen(opc);
	/*
		Se determina el nmero de funciones
	 */
	while(fun[numFunciones])
		numFunciones++;
	/*
		Si numOpciones y numFunciones no coinciden,
		se emite un mensaje de error y se abandona
		la ejecucin del programa.
	 */
	if (numOpciones != numFunciones)
	{
		printf("\n\nError fatal: numOpciones (%d) =! numFunciones (%d)\n\n",
				numOpciones, numFunciones);
		exit(1);
	}
	/*
		Si todo va bien, se crea una nueva estructura de datos
		para simplificar la ejecucin. Se puede pensar que se trata
		de una tabla dispersiva (vase Hash Table) muy primitiva.

		El mecanismo consiste en crear una tabla formada por 256 posibles
		valores de tipo pfuncion. En cada posicin de la tabla se almacena
		originalmente la direccin volver.
	 */
	f = malloc(256*sizeof(funRef));
	for(i=0;i<256;i++)
		f[i] = volver;
	/*
		A continuacin, se recorre la lista de opciones correspondientes
		a funciones. Cada opcin es un nmero. Se utiliza ese nmero como ndice
		dentro de la lista de funciones, y en la posicin correspondiente
		se almacena el puntero de funcin asociado a esa opcin.

		Segn se ha construido la aplicacin, opc[i] es la i-sima opcin
		(por ejemplo, opc[0] es 'A'), y tiene asociada fun[i] (por ejemplo,
		fun[0] es &altas). Se toma la opcin (por ejemplo, 'A', esto es, 65) como
		ndice dentro de la tabla f[] y se hace f[opc[i]] = fun[i]. En nuestro caso,
		estaramos haciendo f[65] = &altas;
	 */
	for(i=0;i<numOpciones;i++)
		f[(int)opc[i]] = fun[i];
	/************************************************************
		Ahora la opcin pulsada por el usuario es directamente
		el ndice de la funcin seleccionada
	 *************************************************************/
	do
	{
		printf("%s ", men);
		fgets(buf, 16, stdin);
		orden = toupper(buf[0]);
		f[(int)orden](g);
	} while (!g->salirDePrograma);
	free(f);
}
